Index: src/ThermoStatContainer.hpp
===================================================================
--- src/ThermoStatContainer.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/ThermoStatContainer.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -14,8 +14,7 @@
 #endif
 
+#include "Thermostats/Thermostat.hpp"
+
 class ConfigFileBuffer;
-
-#define MaxThermostats 6      //!< maximum number of thermostat entries in Ions#ThermostatNames and Ions#ThermostatImplemented
-enum thermostats { None, Woodcock, Gaussian, Langevin, Berendsen, NoseHoover };   //!< Thermostat names for output
 
 class ThermoStatContainer {
@@ -23,15 +22,13 @@
   ThermoStatContainer();
   ~ThermoStatContainer();
+  ThermostatTraits<Thermostat> *getTraitByName(const std::string name);
+  Thermostat *makeByName(const std::string name,class ConfigFileBuffer * const fb);
+  void makeActive(const std::string name,class ConfigFileBuffer * const fb);
+  void chooseNone();
 
-  void ParseThermostats(class ConfigFileBuffer * const fb);
-
-  int Thermostat;
-  int *ThermostatImplemented;
-  char **ThermostatNames;
-  double TempFrequency;
-  double alpha;
-  double HooverMass;
+  Thermostat* activeThermostat;
+  typedef std::map<std::string,ThermostatTraits<Thermostat>* > traitsMap;
+  traitsMap availThermostats;
   double TargetTemp;
-  int ScaleTempStep;
 };
 
Index: src/Thermostats/Berendsen.cpp
===================================================================
--- src/Thermostats/Berendsen.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Thermostats/Berendsen.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,75 @@
+/*
+ * Berendsen.cpp
+ *
+ *  Created on: Aug 20, 2010
+ *      Author: crueger
+ */
+
+#include "Berendsen.hpp"
+#include "element.hpp"
+#include "config.hpp"
+#include "Helpers/Verbose.hpp"
+#include "Helpers/Log.hpp"
+#include "ThermoStatContainer.hpp"
+#include "World.hpp"
+
+Berendsen::Berendsen(double _TempFrequency) :
+  TempFrequency(_TempFrequency)
+{}
+
+Berendsen::Berendsen() :
+  TempFrequency(2.5)
+{}
+
+Berendsen::~Berendsen()
+{}
+
+const char *ThermostatTraits<Berendsen>::name = "Berendsen";
+
+std::string ThermostatTraits<Berendsen>::getName(){
+  return ThermostatTraits<Berendsen>::name;
+}
+
+Thermostat *ThermostatTraits<Berendsen>::make(class ConfigFileBuffer * const fb){
+  double TempFrequency;
+  const int verbose = 0;
+  ParseForParameter(verbose,fb,"Thermostat", 0, 2, 1, double_type, &TempFrequency, 1, critical); // read \tau_T
+  return new Berendsen(TempFrequency);
+}
+
+double Berendsen::scaleAtoms(unsigned int step,double ActualTemp,ATOMSET(std::list) atoms){
+  return doScaleAtoms(step,ActualTemp,atoms.begin(),atoms.end());
+}
+
+double Berendsen::scaleAtoms(unsigned int step,double ActualTemp,ATOMSET(std::vector) atoms){
+  return doScaleAtoms(step,ActualTemp,atoms.begin(),atoms.end());
+}
+
+double Berendsen::scaleAtoms(unsigned int step,double ActualTemp,ATOMSET(std::set) atoms){
+  return doScaleAtoms(step,ActualTemp,atoms.begin(),atoms.end());
+}
+
+template <class ForwardIterator>
+double Berendsen::doScaleAtoms(unsigned int step,double ActualTemp,ForwardIterator begin, ForwardIterator end){
+  DoLog(2) && (Log() << Verbose(2) <<  "Applying Berendsen-VanGunsteren thermostat..." << endl);
+  double ekin=0;
+  double ScaleTempFactor = getContainer().TargetTemp/ActualTemp;
+  for(ForwardIterator iter=begin;iter!=end;++iter){
+    Vector &U = (*iter)->Trajectory.U.at(step);
+    if ((*iter)->FixedIon == 0) { // even FixedIon moves, only not by other's forces
+      U *= sqrt(1+(World::getInstance().getConfig()->Deltat/TempFrequency)*(ScaleTempFactor-1));
+      ekin += 0.5*(*iter)->getType()->getMass() * U.NormSquared();
+    }
+  }
+  return ekin;
+}
+
+std::string Berendsen::name(){
+  return ThermostatTraits<Berendsen>::name;
+}
+
+std::string Berendsen::writeParams(){
+  stringstream sstr;
+  sstr << TempFrequency;
+  return sstr.str();
+}
Index: src/Thermostats/Berendsen.hpp
===================================================================
--- src/Thermostats/Berendsen.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Thermostats/Berendsen.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,43 @@
+/*
+ * Berendsen.hpp
+ *
+ *  Created on: Aug 20, 2010
+ *      Author: crueger
+ */
+
+#ifndef BERENDSEN_HPP_
+#define BERENDSEN_HPP_
+
+#include "Thermostats/Thermostat.hpp"
+
+class Berendsen : public Thermostat
+{
+public:
+  Berendsen(double);
+  Berendsen();
+  virtual ~Berendsen();
+
+  virtual double scaleAtoms(unsigned int step,double ActualTemp,ATOMSET(std::list) atoms);
+  virtual double scaleAtoms(unsigned int step,double ActualTemp,ATOMSET(std::vector) atoms);
+  virtual double scaleAtoms(unsigned int step,double ActualTemp,ATOMSET(std::set) atoms);
+
+  virtual std::string name();
+
+  virtual std::string writeParams();
+
+private:
+  template <class ForwardIterator>
+  double doScaleAtoms(unsigned int step,double ActualTemp,ForwardIterator begin, ForwardIterator end);
+
+  double TempFrequency;
+};
+
+template <>
+struct ThermostatTraits<class Berendsen> : public ThermostatTraits<Thermostat>
+{
+  virtual Thermostat *make(class ConfigFileBuffer * const fb);
+  virtual std::string getName();
+  static const char* name;
+};
+
+#endif /* BERENDSEN_HPP_ */
Index: src/Thermostats/GaussianThermostat.cpp
===================================================================
--- src/Thermostats/GaussianThermostat.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Thermostats/GaussianThermostat.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,104 @@
+/*
+ * GaussianThermostat.cpp
+ *
+ *  Created on: Aug 18, 2010
+ *      Author: crueger
+ */
+
+#include "GaussianThermostat.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "AtomSet.hpp"
+#include "element.hpp"
+#include "config.hpp"
+#include "World.hpp"
+
+#include <set>
+
+GaussianThermostat::GaussianThermostat(int _ScaleTempStep) :
+  E(0),G(0),
+  ScaleTempStep(_ScaleTempStep)
+{}
+
+GaussianThermostat::GaussianThermostat() :
+  E(0),G(0),
+  ScaleTempStep(25)
+{}
+
+GaussianThermostat::~GaussianThermostat()
+{}
+
+const char *ThermostatTraits<GaussianThermostat>::name = "Gaussian";
+
+std::string ThermostatTraits<GaussianThermostat>::getName(){
+  return ThermostatTraits<GaussianThermostat>::name;
+}
+
+Thermostat *ThermostatTraits<GaussianThermostat>::make(class ConfigFileBuffer * const fb){
+  int ScaleTempStep;
+  const int verbose = 0;
+  ParseForParameter(verbose,fb,"Thermostat", 0, 2, 1, int_type, &ScaleTempStep, 1, critical); // read collision rate
+  return new class GaussianThermostat(ScaleTempStep);
+}
+
+double GaussianThermostat::scaleAtoms(unsigned int step,double ActualTemp,ATOMSET(std::list) atoms){
+  return doScaleAtoms(step,ActualTemp,atoms.begin(),atoms.end());
+}
+
+double GaussianThermostat::scaleAtoms(unsigned int step,double ActualTemp,ATOMSET(std::vector) atoms){
+  return doScaleAtoms(step,ActualTemp,atoms.begin(),atoms.end());
+}
+
+double GaussianThermostat::scaleAtoms(unsigned int step,double ActualTemp,ATOMSET(std::set) atoms){
+  return doScaleAtoms(step,ActualTemp,atoms.begin(),atoms.end());
+}
+
+template <class ForwardIterator>
+double GaussianThermostat::doScaleAtoms(unsigned int step,double ActualTemp,ForwardIterator begin, ForwardIterator end){
+  DoLog(2) && (Log() << Verbose(2) <<  "Applying Gaussian thermostat..." << endl);
+  init(step,begin,end);
+  double G_over_E = G/E;
+  DoLog(1) && (Log() << Verbose(1) << "Gaussian Least Constraint constant is " << G_over_E << "." << endl);
+  double ekin =0;
+  for(ForwardIterator iter=begin;iter!=end;++iter){
+    Vector &U = (*iter)->Trajectory.U.at(step);
+    if ((*iter)->FixedIon == 0) {// even FixedIon moves, only not by other's forces
+      U += World::getInstance().getConfig()->Deltat * G_over_E * U;
+      ekin += (*iter)->getType()->getMass() * U.NormSquared();
+    }
+  }
+  return ekin;
+}
+
+template <class ForwardIterator>
+void GaussianThermostat::init(unsigned int step,ForwardIterator begin, ForwardIterator end){
+  E=0;
+  G=0;
+  for(ForwardIterator iter=begin;iter!=end;++iter){
+    Vector &U = (*iter)->Trajectory.U.at(step);
+    Vector &F = (*iter)->Trajectory.F.at(step);
+    if ((*iter)->FixedIon == 0){ // even FixedIon moves, only not by other's forces
+      G += U.ScalarProduct(F);
+      E += U.NormSquared()*(*iter)->getType()->getMass();
+    }
+  }
+}
+
+double GaussianThermostat::getE() const{
+  return E;
+}
+
+double GaussianThermostat::getG() const{
+  return G;
+}
+
+std::string GaussianThermostat::name(){
+  return ThermostatTraits<GaussianThermostat>::name;
+}
+
+std::string GaussianThermostat::writeParams(){
+  std::stringstream sstr;
+  sstr << ScaleTempStep;
+  return sstr.str();
+}
Index: src/Thermostats/GaussianThermostat.hpp
===================================================================
--- src/Thermostats/GaussianThermostat.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Thermostats/GaussianThermostat.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,48 @@
+/*
+ * GaussianThermostat.hpp
+ *
+ *  Created on: Aug 18, 2010
+ *      Author: crueger
+ */
+
+#ifndef GAUSSIANTHERMOSTAT_HPP_
+#define GAUSSIANTHERMOSTAT_HPP_
+
+#include "Thermostats/Thermostat.hpp"
+
+class config;
+
+class GaussianThermostat : public Thermostat
+{
+public:
+  GaussianThermostat(int ScaleTempStep);
+  GaussianThermostat();
+  virtual ~GaussianThermostat();
+
+  virtual double scaleAtoms(unsigned int step,double ActualTemp,ATOMSET(std::list) atoms);
+  virtual double scaleAtoms(unsigned int step,double ActualTemp,ATOMSET(std::vector) atoms);
+  virtual double scaleAtoms(unsigned int step,double ActualTemp,ATOMSET(std::set) atoms);
+
+  double getE() const;
+  double getG() const;
+
+  virtual std::string name();
+  virtual std::string writeParams();
+private:
+  template <class ForwardIterator>
+  void init(unsigned int step,ForwardIterator begin, ForwardIterator end);
+  template <class ForwardIterator>
+  double doScaleAtoms(unsigned int step,double ActualTemp,ForwardIterator begin, ForwardIterator end);
+  double E,G;
+  int ScaleTempStep;
+};
+
+template <>
+struct ThermostatTraits<GaussianThermostat> : public ThermostatTraits<Thermostat>
+{
+  virtual Thermostat *make(class ConfigFileBuffer * const fb);
+  virtual std::string getName();
+  static const char* name;
+};
+
+#endif /* GAUSSIANTHERMOSTAT_HPP_ */
Index: src/Thermostats/Langevin.cpp
===================================================================
--- src/Thermostats/Langevin.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Thermostats/Langevin.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,96 @@
+/*
+ * Langevin.cpp
+ *
+ *  Created on: Aug 20, 2010
+ *      Author: crueger
+ */
+
+#include "Langevin.hpp"
+#include "element.hpp"
+#include "config.hpp"
+#include "Helpers/Verbose.hpp"
+#include "Helpers/Log.hpp"
+#include "ThermoStatContainer.hpp"
+
+Langevin::Langevin(double _TempFrequency,double _alpha) :
+  TempFrequency(_TempFrequency),
+  alpha(_alpha)
+{
+  gsl_rng_env_setup();
+  T = gsl_rng_default;
+  r = gsl_rng_alloc (T);
+}
+
+Langevin::Langevin() :
+  TempFrequency(2.5),
+  alpha(0.)
+{}
+
+Langevin::~Langevin()
+{
+  gsl_rng_free (r);
+}
+
+const char *ThermostatTraits<Langevin>::name = "Langevin";
+
+std::string ThermostatTraits<Langevin>::getName(){
+  return ThermostatTraits<Langevin>::name;
+}
+
+Thermostat *ThermostatTraits<Langevin>::make(class ConfigFileBuffer * const fb){
+  double TempFrequency;
+  double alpha;
+  const int verbose = 0;
+  ParseForParameter(verbose,fb,"Thermostat", 0, 2, 1, double_type, &TempFrequency, 1, critical); // read gamma
+  if (ParseForParameter(verbose,fb,"Thermostat", 0, 3, 1, double_type, &alpha, 1, optional)) {
+    DoLog(2) && (Log() << Verbose(2) << "Extended Stochastic Thermostat detected with interpolation coefficient " << alpha << "." << endl);
+  } else {
+    alpha = 1.;
+  }
+  return new Langevin(TempFrequency,alpha);
+}
+
+double Langevin::scaleAtoms(unsigned int step,double ActualTemp,ATOMSET(std::list) atoms){
+  return doScaleAtoms(step,ActualTemp,atoms.begin(),atoms.end());
+}
+
+double Langevin::scaleAtoms(unsigned int step,double ActualTemp,ATOMSET(std::vector) atoms){
+  return doScaleAtoms(step,ActualTemp,atoms.begin(),atoms.end());
+}
+
+double Langevin::scaleAtoms(unsigned int step,double ActualTemp,ATOMSET(std::set) atoms){
+  return doScaleAtoms(step,ActualTemp,atoms.begin(),atoms.end());
+}
+
+template <class ForwardIterator>
+double Langevin::doScaleAtoms(unsigned int step,double ActualTemp,ForwardIterator begin, ForwardIterator end){
+  DoLog(2) && (Log() << Verbose(2) <<  "Applying Langevin thermostat..." << endl);
+  double ekin=0;
+  for(ForwardIterator iter=begin;iter!=end;++iter){
+    double sigma  = sqrt(getContainer().TargetTemp/(*iter)->getType()->getMass()); // sigma = (k_b T)/m (Hartree/atomicmass = atomiclength/atomictime)
+    Vector &U = (*iter)->Trajectory.U.at(step);
+    if ((*iter)->FixedIon == 0) { // even FixedIon moves, only not by other's forces
+      // throw a dice to determine whether it gets hit by a heat bath particle
+      if (((((rand()/(double)RAND_MAX))*TempFrequency) < 1.)) {
+        DoLog(3) && (Log() << Verbose(3) << "Particle " << (**iter) << " was hit (sigma " << sigma << "): " << U.Norm() << " -> ");
+        // pick three random numbers from a Boltzmann distribution around the desired temperature T for each momenta axis
+        for (int d=0; d<NDIM; d++) {
+          U[d] = gsl_ran_gaussian (r, sigma);
+        }
+        DoLog(2) && (Log() << Verbose(2) << U.Norm() << endl);
+      }
+      ekin += 0.5*(*iter)->getType()->getMass() * U.NormSquared();
+    }
+  }
+  return ekin;
+}
+
+std::string Langevin::name(){
+  return ThermostatTraits<Langevin>::name;
+}
+
+std::string Langevin::writeParams(){
+  stringstream sstr;
+  sstr << TempFrequency << "\t" << alpha;
+  return sstr.str();
+}
Index: src/Thermostats/Langevin.hpp
===================================================================
--- src/Thermostats/Langevin.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Thermostats/Langevin.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,46 @@
+/*
+ * Langevin.hpp
+ *
+ *  Created on: Aug 20, 2010
+ *      Author: crueger
+ */
+
+#ifndef LANGEVIN_HPP_
+#define LANGEVIN_HPP_
+
+#include "Thermostats/Thermostat.hpp"
+
+class Langevin : public Thermostat
+{
+public:
+  Langevin(double,double);
+  Langevin();
+  virtual ~Langevin();
+
+  virtual double scaleAtoms(unsigned int step,double ActualTemp,ATOMSET(std::list) atoms);
+  virtual double scaleAtoms(unsigned int step,double ActualTemp,ATOMSET(std::vector) atoms);
+  virtual double scaleAtoms(unsigned int step,double ActualTemp,ATOMSET(std::set) atoms);
+
+  virtual std::string name();
+  virtual std::string writeParams();
+
+private:
+  template <class ForwardIterator>
+  double doScaleAtoms(unsigned int step,double ActualTemp,ForwardIterator begin, ForwardIterator end);
+
+
+  double TempFrequency;
+  double alpha;
+  gsl_rng * r;
+  const gsl_rng_type * T;
+};
+
+template <>
+struct ThermostatTraits<class Langevin> : public ThermostatTraits<Thermostat>
+{
+  virtual Thermostat *make(class ConfigFileBuffer * const fb);
+  virtual std::string getName();
+  static const char* name;
+};
+
+#endif /* LANGEVIN_HPP_ */
Index: src/Thermostats/NoThermostat.cpp
===================================================================
--- src/Thermostats/NoThermostat.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Thermostats/NoThermostat.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,44 @@
+/*
+ * NoThermostat.cpp
+ *
+ *  Created on: Aug 20, 2010
+ *      Author: crueger
+ */
+
+#include "NoThermostat.hpp"
+
+NoThermostat::NoThermostat()
+{}
+
+NoThermostat::~NoThermostat()
+{}
+
+const char *ThermostatTraits<NoThermostat>::name = "None";
+
+std::string ThermostatTraits<NoThermostat>::getName(){
+  return ThermostatTraits<NoThermostat>::name;
+}
+
+Thermostat *ThermostatTraits<NoThermostat>::make(class ConfigFileBuffer * const fb){
+  return new NoThermostat();
+}
+
+double NoThermostat::scaleAtoms(unsigned int step,double ActualTemp,ATOMSET(std::list) atoms){
+  return 0;
+}
+
+double NoThermostat::scaleAtoms(unsigned int step,double ActualTemp,ATOMSET(std::vector) atoms){
+  return 0;
+}
+
+double NoThermostat::scaleAtoms(unsigned int step,double ActualTemp,ATOMSET(std::set) atoms){
+  return 0;
+}
+
+std::string NoThermostat::name(){
+  return ThermostatTraits<NoThermostat>::name;
+}
+
+std::string NoThermostat::writeParams(){
+  return "";
+}
Index: src/Thermostats/NoThermostat.hpp
===================================================================
--- src/Thermostats/NoThermostat.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Thermostats/NoThermostat.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,35 @@
+/*
+ * NoThermostat.hpp
+ *
+ *  Created on: Aug 20, 2010
+ *      Author: crueger
+ */
+
+#ifndef NOTHERMOSTAT_HPP_
+#define NOTHERMOSTAT_HPP_
+
+#include "Thermostats/Thermostat.hpp"
+
+class NoThermostat : public Thermostat
+{
+public:
+  NoThermostat();
+  virtual ~NoThermostat();
+
+  virtual double scaleAtoms(unsigned int step,double ActualTemp,ATOMSET(std::list) atoms);
+  virtual double scaleAtoms(unsigned int step,double ActualTemp,ATOMSET(std::vector) atoms);
+  virtual double scaleAtoms(unsigned int step,double ActualTemp,ATOMSET(std::set) atoms);
+
+  virtual std::string name();
+  virtual std::string writeParams();
+};
+
+template <>
+struct ThermostatTraits<class NoThermostat>: public ThermostatTraits<Thermostat>
+{
+  virtual Thermostat *make(class ConfigFileBuffer * const fb);
+  virtual std::string getName();
+  static const char* name;
+};
+
+#endif /* NOTHERMOSTAT_HPP_ */
Index: src/Thermostats/NoseHoover.cpp
===================================================================
--- src/Thermostats/NoseHoover.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Thermostats/NoseHoover.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,93 @@
+/*
+ * NoseHoover.cpp
+ *
+ *  Created on: Aug 20, 2010
+ *      Author: crueger
+ */
+
+#include "NoseHoover.hpp"
+
+#include "element.hpp"
+#include "config.hpp"
+#include "Helpers/Verbose.hpp"
+#include "Helpers/Log.hpp"
+#include "ThermoStatContainer.hpp"
+#include "World.hpp"
+
+NoseHoover::NoseHoover(double _HooverMass) :
+  HooverMass(_HooverMass),
+  alpha(0)
+{}
+
+NoseHoover::NoseHoover() :
+  HooverMass(0.)
+{}
+
+NoseHoover::~NoseHoover()
+{}
+
+const char *ThermostatTraits<NoseHoover>::name = "NoseHoover";
+
+std::string ThermostatTraits<NoseHoover>::getName(){
+  return ThermostatTraits<NoseHoover>::name;
+}
+
+Thermostat *ThermostatTraits<NoseHoover>::make(class ConfigFileBuffer * const fb){
+  double HooverMass;
+  const int verbose = 0;
+  ParseForParameter(verbose,fb,"Thermostat", 0, 2, 1, double_type, &HooverMass, 1, critical); // read Hoovermass
+  return new NoseHoover(HooverMass);
+}
+
+double NoseHoover::scaleAtoms(unsigned int step,double ActualTemp,ATOMSET(std::list) atoms){
+  return doScaleAtoms(step,ActualTemp,atoms.begin(),atoms.end());
+}
+
+double NoseHoover::scaleAtoms(unsigned int step,double ActualTemp,ATOMSET(std::vector) atoms){
+  return doScaleAtoms(step,ActualTemp,atoms.begin(),atoms.end());
+}
+
+double NoseHoover::scaleAtoms(unsigned int step,double ActualTemp,ATOMSET(std::set) atoms){
+  return doScaleAtoms(step,ActualTemp,atoms.begin(),atoms.end());
+}
+
+template <class ForwardIterator>
+double NoseHoover::doScaleAtoms(unsigned int step,double ActualTemp,ForwardIterator begin, ForwardIterator end){
+  DoLog(2) && (Log() << Verbose(2) <<  "Applying Nose-Hoover thermostat..." << endl);
+  init(step,begin,end);
+  delta_alpha = (delta_alpha - (3.*count+1.) * getContainer().TargetTemp)/(HooverMass*Units2Electronmass);
+  alpha += delta_alpha*World::getInstance().getConfig()->Deltat;
+  DoLog(3) && (Log() << Verbose(3) << "alpha = " << delta_alpha << " * " << World::getInstance().getConfig()->Deltat << " = " << alpha << "." << endl);
+  double ekin =0;
+  for(ForwardIterator iter=begin;iter!=end;++iter){
+    Vector &U = (*iter)->Trajectory.U.at(step);
+    if ((*iter)->FixedIon == 0) { // even FixedIon moves, only not by other's forces
+      U += World::getInstance().getConfig()->Deltat/(*iter)->getType()->getMass() * (alpha * (U * (*iter)->getType()->getMass()));
+      ekin += (0.5*(*iter)->getType()->getMass()) * U.NormSquared();
+    }
+  }
+  return ekin;
+}
+
+template <class ForwardIterator>
+void NoseHoover::init(unsigned int step,ForwardIterator begin, ForwardIterator end){
+  delta_alpha=0;
+  count=0;
+  for(ForwardIterator iter = begin;iter!=end;++iter){
+    Vector &U = (*iter)->Trajectory.U.at(step);
+    if ((*iter)->FixedIon == 0) { // even FixedIon moves, only not by other's forces
+      delta_alpha += U.NormSquared()*(*iter)->getType()->getMass();
+    }
+    ++count;
+  }
+}
+
+std::string NoseHoover::name(){
+  return ThermostatTraits<NoseHoover>::name;
+}
+
+std::string NoseHoover::writeParams(){
+  std::stringstream sstr;
+  sstr << HooverMass;
+  return sstr.str();
+}
Index: src/Thermostats/NoseHoover.hpp
===================================================================
--- src/Thermostats/NoseHoover.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Thermostats/NoseHoover.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,48 @@
+/*
+ * NoseHoover.hpp
+ *
+ *  Created on: Aug 20, 2010
+ *      Author: crueger
+ */
+
+#ifndef NOSEHOOVER_HPP_
+#define NOSEHOOVER_HPP_
+
+#include "Thermostats/Thermostat.hpp"
+
+class NoseHoover : public Thermostat
+{
+public:
+  NoseHoover(double _HooverMass);
+  NoseHoover();
+  virtual ~NoseHoover();
+
+  virtual double scaleAtoms(unsigned int step,double ActualTemp,ATOMSET(std::list) atoms);
+  virtual double scaleAtoms(unsigned int step,double ActualTemp,ATOMSET(std::vector) atoms);
+  virtual double scaleAtoms(unsigned int step,double ActualTemp,ATOMSET(std::set) atoms);
+
+  virtual std::string name();
+  virtual std::string writeParams();
+
+private:
+  template <class ForwardIterator>
+  void init(unsigned int step,ForwardIterator begin, ForwardIterator end);
+  template <class ForwardIterator>
+  double doScaleAtoms(unsigned int step,double ActualTemp,ForwardIterator begin, ForwardIterator end);
+
+  double HooverMass;
+  double delta_alpha;
+  double alpha;
+  int count;
+};
+
+template <>
+struct ThermostatTraits<class NoseHoover> : public ThermostatTraits<Thermostat>
+{
+  virtual Thermostat *make(class ConfigFileBuffer * const fb);
+  virtual std::string getName();
+  static const char* name;
+};
+
+
+#endif /* NOSEHOOVER_HPP_ */
Index: src/Thermostats/Thermostat.cpp
===================================================================
--- src/Thermostats/Thermostat.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Thermostats/Thermostat.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,32 @@
+/*
+ * Thermostat.cpp
+ *
+ *  Created on: Aug 18, 2010
+ *      Author: crueger
+ */
+
+#include "Thermostat.hpp"
+
+#include "Helpers/Assert.hpp"
+
+Thermostat::Thermostat() :
+  container(0)
+{}
+
+Thermostat::~Thermostat()
+{}
+
+const char *ThermostatTraits<Thermostat>::name = "Base";
+
+std::string ThermostatTraits<Thermostat>::getName(){
+  return ThermostatTraits<Thermostat>::name;
+}
+
+void Thermostat::addToContainer(ThermoStatContainer *_container){
+  container = _container;
+}
+
+ThermoStatContainer &Thermostat::getContainer(){
+  ASSERT(container,"No container used for this Thermostat");
+  return *container;
+}
Index: src/Thermostats/Thermostat.hpp
===================================================================
--- src/Thermostats/Thermostat.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Thermostats/Thermostat.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,52 @@
+/*
+ * Thermostat.hpp
+ *
+ *  Created on: Aug 18, 2010
+ *      Author: crueger
+ */
+
+#ifndef THERMOSTAT_HPP_
+#define THERMOSTAT_HPP_
+
+class config;
+
+#include <string>
+#include <set>
+#include <vector>
+#include <list>
+#include "AtomSet.hpp"
+
+class ThermoStatContainer;
+
+class Thermostat
+{
+public:
+  Thermostat();
+  virtual ~Thermostat();
+
+  // cannot template this, because we need virtual functions
+  virtual double scaleAtoms(unsigned int step,double ActualTemp,ATOMSET(std::list) atoms)=0;
+  virtual double scaleAtoms(unsigned int step,double ActualTemp,ATOMSET(std::vector) atoms)=0;
+  virtual double scaleAtoms(unsigned int step,double ActualTemp,ATOMSET(std::set) atoms)=0;
+
+  virtual std::string name()=0;
+
+  virtual std::string writeParams()=0;
+  void addToContainer(ThermoStatContainer *);
+protected:
+  ThermoStatContainer &getContainer();
+private:
+  ThermoStatContainer* container;
+};
+
+template <class Thermostat>
+struct ThermostatTraits;
+
+template <>
+struct ThermostatTraits<Thermostat>{
+  virtual Thermostat *make(class ConfigFileBuffer * const fb)=0;
+  virtual std::string getName();
+  static const char* name;
+};
+
+#endif /* THERMOSTAT_HPP_ */
Index: src/Thermostats/Woodcock.cpp
===================================================================
--- src/Thermostats/Woodcock.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Thermostats/Woodcock.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,80 @@
+/*
+ * Woodcock.cpp
+ *
+ *  Created on: Aug 20, 2010
+ *      Author: crueger
+ */
+
+#include "Woodcock.hpp"
+
+#include "element.hpp"
+#include "config.hpp"
+#include "Helpers/Verbose.hpp"
+#include "Helpers/Log.hpp"
+#include "ThermoStatContainer.hpp"
+
+#include <sstream>
+
+Woodcock::Woodcock(int _ScaleTempStep) :
+  ScaleTempStep(_ScaleTempStep)
+{}
+
+Woodcock::Woodcock() :
+  ScaleTempStep(25)
+{}
+
+Woodcock::~Woodcock()
+{}
+
+const char *ThermostatTraits<Woodcock>::name = "Woodcock";
+
+std::string ThermostatTraits<Woodcock>::getName(){
+  return ThermostatTraits<Woodcock>::name;
+}
+
+Thermostat *ThermostatTraits<Woodcock>::make(class ConfigFileBuffer * const fb){
+  int ScaleTempStep;
+  const int verbose = 0;
+  ParseForParameter(verbose,fb,"Thermostat", 0, 2, 1, int_type, &ScaleTempStep, 1, critical); // read scaling frequency
+  return new Woodcock(ScaleTempStep);
+}
+
+double Woodcock::scaleAtoms(unsigned int step,double ActualTemp,ATOMSET(std::list) atoms){
+  return doScaleAtoms(step,ActualTemp,atoms.begin(),atoms.end());
+}
+
+double Woodcock::scaleAtoms(unsigned int step,double ActualTemp,ATOMSET(std::vector) atoms){
+  return doScaleAtoms(step,ActualTemp,atoms.begin(),atoms.end());
+}
+
+double Woodcock::scaleAtoms(unsigned int step,double ActualTemp,ATOMSET(std::set) atoms){
+  return doScaleAtoms(step,ActualTemp,atoms.begin(),atoms.end());
+}
+
+template <class ForwardIterator>
+double Woodcock::doScaleAtoms(unsigned int step,double ActualTemp,ForwardIterator begin,ForwardIterator end){
+  double ekin=0;
+  if ((ScaleTempStep > 0) && ((step-1) % ScaleTempStep == 0)) {
+    double ScaleTempFactor = sqrt(getContainer().TargetTemp/ActualTemp);
+    DoLog(2) && (Log() << Verbose(2) <<  "Applying Woodcock thermostat..." << endl);
+    double ekin;
+    for (ForwardIterator iter = begin; iter!=end;++iter){
+      Vector &U = (*iter)->Trajectory.U.at(step);
+      if ((*iter)->FixedIon == 0){ // even FixedIon moves, only not by other's forces
+        U *= ScaleTempFactor;
+        ekin += 0.5*(*iter)->getType()->getMass() * U.NormSquared();
+      }
+    }
+  }
+  return ekin;
+}
+
+std::string Woodcock::name(){
+  return ThermostatTraits<Woodcock>::name;
+}
+
+std::string Woodcock::writeParams(){
+  std::stringstream sstr;
+  sstr << ScaleTempStep;
+  return sstr.str();
+}
Index: src/Thermostats/Woodcock.hpp
===================================================================
--- src/Thermostats/Woodcock.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Thermostats/Woodcock.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,43 @@
+/*
+ * Woodcock.hpp
+ *
+ *  Created on: Aug 20, 2010
+ *      Author: crueger
+ */
+
+#ifndef WOODCOCK_HPP_
+#define WOODCOCK_HPP_
+
+#include "Thermostats/Thermostat.hpp"
+
+class Woodcock : public Thermostat
+{
+public:
+  Woodcock(int);
+  Woodcock();
+  virtual ~Woodcock();
+
+  virtual double scaleAtoms(unsigned int step,double ActualTemp,ATOMSET(std::list) atoms);
+  virtual double scaleAtoms(unsigned int step,double ActualTemp,ATOMSET(std::vector) atoms);
+  virtual double scaleAtoms(unsigned int step,double ActualTemp,ATOMSET(std::set) atoms);
+
+  virtual std::string name();
+
+  virtual std::string writeParams();
+
+private:
+  template <class ForwardIterator>
+  double doScaleAtoms(unsigned int step,double ActualTemp,ForwardIterator begin,ForwardIterator end);
+
+  int ScaleTempStep;
+};
+
+template <>
+struct ThermostatTraits<class Woodcock> : public ThermostatTraits<Thermostat>
+{
+  virtual Thermostat *make(class ConfigFileBuffer * const fb);
+  virtual std::string getName();
+  static const char* name;
+};
+
+#endif /* WOODCOCK_HPP_ */
Index: src/UIElements/CommandLineUI/CommandLineDialog.cpp
===================================================================
--- src/UIElements/CommandLineUI/CommandLineDialog.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/UIElements/CommandLineUI/CommandLineDialog.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * CommandLineDialog.cpp
@@ -6,4 +13,9 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
@@ -23,8 +35,8 @@
 #include "CommandLineParser.hpp"
 #include "defs.hpp"
-#include "log.hpp"
-#include "Matrix.hpp"
+#include "Helpers/Log.hpp"
+#include "LinearAlgebra/Matrix.hpp"
 #include "periodentafel.hpp"
-#include "verbose.hpp"
+#include "Helpers/Verbose.hpp"
 #include "World.hpp"
 #include "Box.hpp"
@@ -33,5 +45,5 @@
 #include "element.hpp"
 #include "molecule.hpp"
-#include "vector.hpp"
+#include "LinearAlgebra/Vector.hpp"
 
 using namespace std;
Index: src/UIElements/CommandLineUI/CommandLineStatusIndicator.cpp
===================================================================
--- src/UIElements/CommandLineUI/CommandLineStatusIndicator.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/UIElements/CommandLineUI/CommandLineStatusIndicator.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * CommandLineStatusIndicator.cpp
@@ -5,4 +12,9 @@
  *      Author: heber
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
